echo("initiating a wee bit of tomfoolery");

$renderactivity = 0; // this doesn't affect anything except the frequency that the renderman detector beeps at:
//lastHorrorObjectSeen = 0;
// 0: Nothing
// 1: Not much going on, slow beep
// 2: Slightly faster beep
// 3: SIR I AM GETTING SOME STRANGE READINGS SIR
// 4: Quick beep
// 5: Ballistic beep

// uses datablock "Beep_EKG_Sound" OR the detector sound from v3 (toggable)

$rendercurrentlystalking = 0; //to prevent excessive bangs/renderman spawns
$renderstalkcount = 0;

function createRenderman(%pos) { // creates a renderman at the specified pos
    $renderactivity = 3;
	%this = new aiplayer(RenderMan) {
		datablock = PlayerRender;
		position = %pos;
	};
	missionCleanup.add(%this);
	hideAllNodes(%this);
	if($Pref::Renderman::Appearance == 1) {
		%type = getRandom(1,16);
	}
	if(%type >= 15) {		//based on Dr.Block's videos
		%this.unhidenode(femchest);
        %this.unhidenode(pants);
        %this.unhidenode(LShoe);
		%this.unhidenode(RShoe);
        %this.unhidenode(LArm);
        %this.unhidenode(LHook);
        %this.unhidenode(RArm);
        %this.unhidenode(RHook);
        %this.setnodecolor(femchest, "0 0 0 1");
        %this.setnodecolor(headskin, "0 0 0 1");
        %this.setnodecolor(pants, "0 0 0 1");
        %this.setnodecolor(LPeg, "0 0 0 1");
        %this.setnodecolor(RPeg, "0 0 0 1");
        %this.setnodecolor(LArm, "0 0 0 1");
        %this.setnodecolor(LHook, "0 0 0 1");
        %this.setnodecolor(RArm, "0 0 0 1");
        %this.setnodecolor(RHook, "0 0 0 1");
        %this.setdecalname("AAA-None");
		%height = getRandom(1,16);
		if(%height == 16) {
			%this.setScale("1 1 2");	//Renderful Man
			echo("\c2" @ "STOP LOOKING");
		} else {
			%this.setScale("1 1 1.4");
		}
	} else {
		%this.unhidenode(chest);
		%this.unhidenode(pants);
		%this.unhidenode(LShoe);
		%this.unhidenode(RShoe);
		%this.unhidenode(LArm);
		%this.unhidenode(LHand);
		%this.unhidenode(RArm);
		%this.unhidenode(RHand);
		%this.setnodecolor(chest, "0 0 0 1");
		%this.setnodecolor(headskin, "0 0 0 1");
		%this.setnodecolor(pants, "0 0 0 1");
		%this.setnodecolor(LShoe, "0 0 0 1");
		%this.setnodecolor(RShoe, "0 0 0 1");
		%this.setnodecolor(LArm, "0 0 0 1");
		%this.setnodecolor(LHand, "0 0 0 1");
		%this.setnodecolor(RArm, "0 0 0 1");
		%this.setnodecolor(RHand, "0 0 0 1");
		%this.setdecalname("AAA-None");
	}
	if($Pref::Renderman::Face == 1) {
		%this.setfacename("asciiTerror");
	} else {
        %this.setfacename("memeGrinMan");
    }
	if($Pref::Renderman::Light == 1) {
        %this.light = new fxlight()
		{
			dataBlock = playerLight;
			enable = true;
			iconsize = 1;
			player = %this;
		};
		%this.light.attachToObject(%this);
    }
    $HorrorObject = %this;
	InitContainerRadiusSearch(%pos, 120, $TypeMasks::PlayerObjectType);
	while((%player = containerSearchNext()) != 0) {
		if(isObject(%player.client)) {
			%target = %player;
			break;
		}
	}
	if(isObject(%target))
		%this.setAimObject(%target);
	$RMOD_Support_Delete = schedule(getRandom(3000, 7000), 0, deleteRenderman, %this, %pos);
}

function deleteRenderman(%this,%pos) {
	if(!isObject(%this))
		return;
    ServerPlay2D(Botvanish,%pos);
	%this.delete();
    $renderactivity = 1;
}

function getPosInFrontOfPlayer(%player,%dist)
{
    return vectorAdd(%player.getEyePoint(),vectorScale(%player.getEyeVector(),%dist));
}

function getPosBehindPlayer(%player,%dist)
{
    %dist = %dist * -1;
    return vectorAdd(%player.getEyePoint(),vectorScale(%player.getEyeVector(),%dist));
}

function RMOD_Check(%check)
{
	cancel($RMOD_Check);
	%a = -1;
	%say[%a++] = "Hmmmm....";
	%say[%a++] = "Is someone there?";
	%say[%a++] = "I see you.";
	%say[%a++] = "Hello?";
	%say[%a++] = "dun dun dun...";
	%say[%a++] = "Can you see it yet?";
	%say[%a++] = "Looking for me?";
	%say[%a++] = "What are you looking at?";

	if(!isObject($RMOD_SKD))
	{
		for(%a = 0; %a < 10; %a++)
		{
			if(isObject(MissionGroup))
			{
				%obj = MissionGroup.getObject(%a);

				if(%obj.getClassName() $= "Sun")
				{
					$RMOD_SKD = %obj;
					break;
				}
			}
		}
	}
	%n = $RMOD_SKD.color;

	if(getWord(%n,0) > 0.4 && getWord(%n,1) > 0.4 && getWord(%n,2) > 0.4 || $Pref::Renderman::Enabled == 0)
	{
		$RMOD_Check = schedule( 120000, 0, RMOD_Check, %say[getRandom(0,%a)] );
        $renderactivity = 0;
		return;
	}

	cancel($RMOD_Check);
	if(getRandom(1,30) == 1)
	{
		echo( "\c2" @ %say[getRandom(0,%a)] );
	}
	
	// If there are players...
	if(clientGroup.getCount() > 0)
	{
		%player = clientGroup.getObject( getRandom(0, clientGroup.getCount()-1) ).player;
			
		if(isObject(%player))
		{
			%pPos = %player.getPosition();
			%fPos = vectorAdd(%pPos, getRandom(-30,30) SPC getRandom(-30,30) SPC getRandom(0,15) );
            %pPos = vectorAdd(%pPos, getRandom(-10,10) SPC getRandom(-10,10) SPC getRandom(0,15) );
			
			// // Random Checks // //
			// (mostly) shamelessly stolen from v3
			
			// Lights
            %foundalight = 0;
            if($Pref::Renderman::AffectLight == 1 && getRandom(1,12) == 1) {
                //$renderactivity = 4;
				InitContainerRadiusSearch(%pPos,120,$TypeMasks::FxBrickObjectType);
                while((%targetObject=containerSearchNext()) !$= 0) {
                    if(%targetObject.getLightID() !$= -1) { // light found?
                        if(getRandom(1,2) == 1) {
                            if(getRandom(1,3) == 1) {
                                schedule(getRandom(100,1300),0,renderBreakLight,%targetObject);
                            } else {
                                schedule(getRandom(100,1300),0,renderAffectLight,%targetObject);
                            }
                        }
                    }
                }
            }
			
			// Faces
            if(getRandom(1,3) == 1) { // spawn a face?
                if(getRandom(1,2) == 1) { // super far or super close?
                    %fPos = vectorAdd(%pPos, getRandom(-30,30) SPC getRandom(-30,30) SPC getRandom(0,6) );
                } else {
                    if(%player.shrinefound == 0) { //if he's near a shrine we can't do jack shit
                        %fPos = vectorAdd(%pPos, getRandom(-6,6) SPC getRandom(-6,6) SPC getRandom(0,1) );
                    }
                }
				if($Pref::Renderman::Face == 1) { // face pref
                    %p = new projectile()
                    {
                        dataBlock        = RendermanProjectile2;
                        initialVelocity  = 0;
                        initialPosition  = %fPos;
                    };
                    missionCleanup.add(%p);
                } else {
                    %p = new projectile()
                    {
                        dataBlock        = RendermanProjectile;
                        initialVelocity  = 0;
                        initialPosition  = %fPos;
                    };
                    missionCleanup.add(%p);
                }
				if(getRandom(1,4) == 4) { // should we play a sound sound?
					if($Pref::Renderman::Face == 1) {
						ServerPlay3D(PainCrySound, %fPos); //Prepper sound
					} else {
						ServerPlay3D(Glimpse, %fPos);
					}
				}
				if($Pref::Renderman::Mode == 1) {
					$RMOD_Check = schedule(getRandom(3000,20000),0,RMOD_Check);  
					return; // disallow other random events until next time
				}
            }
			
			//Stalking
			if(getRandom(1,10) == 1 && $rendercurrentlystalking == 0 && $Pref::Renderman::Mode == 0) {	//cant stalk more than once, and also haunting means being less aggressive
				$rendercurrentlystalking = 1;
				%player.stalkLoop();
                $renderactivity = 3;
				$RMOD_Check = schedule(4000,0,RMOD_Check);  
                return; // disallow other random events until next time
            }
			
			// Spawn a Renderman
			if(getRandom(1,5) == 1 && $rendercurrentlystalking == 0) {
                %distance = getRandom(1,2);  // choosing distance
				if(%distance == 1) {	// close
					if(getRandom(1,4) == 1 && %player.shrinefound == 0 && $Pref::Renderman::Mode == 0) { // should we be aggresive (and are we allowed to be)?
						if(getRandom(0,1) == 1) {	// coin flip for if he spawns in front or behind
							%fPos = getPosInFrontOfPlayer(%player,6);
						} else {
							%fPos = getPosBehindPlayer(%player,6);
						}
                    } else {
						%fPos = vectorAdd(%pPos, getRandom(-16,16) SPC getRandom(-16,16) SPC getRandom(0,1) );
					}
				}
				if(%distance == 2) {	//far
                    if(getRandom(0,1) == 1) {
						%fPos = vectorAdd(%pPos, getRandom(-30,30) SPC getRandom(-30,30) SPC getRandom(0,1) );
					} else {
						%fPos = vectorAdd(%pPos, getRandom(-60,60) SPC getRandom(-60,60) SPC getRandom(0,1) );
					}
                }
                createRenderman(%fPos);
				if($Pref::Renderman::Mode == 1) {
					$RMOD_Check = schedule(getRandom(3000,20000),0,RMOD_Check);  
					return; // disallow other random events until next time
				}
            }
			
			// Sounds
            if(getRandom(1,16) == 1) {
                %sound = getRandom(1,3); // pick
				%sPos = vectorAdd(%pPos, getRandom(-10,10) SPC getRandom(-10,10) SPC getRandom(-5,5) );
				
                if(%sound == 1) {
                    ServerPlay2D(Ambient1,%sPos);
                }
                if(%sound == 2) {
                    ServerPlay2D(Ambient2,%sPos);
                }
				if(%sound == 3) {
					ServerPlay2D(Ambient3,%sPos);
				}
				if(%sound == 4) {
					ServerPlay2D(Ambient4,%sPos);
				}
				if($Pref::Renderman::Mode == 1) {
					$RMOD_Check = schedule(getRandom(3000,20000),0,RMOD_Check);  
					return; // disallow other random events until next time
				}
            }
			
			// Sounds (Indoor)
            InitContainerRadiusSearch(%player.getPosition(),60,$TypeMasks::FxBrickObjectType);
            while((%targetObject=containerSearchNext()) !$= 0) {
                %bricksfound = %bricksfound+1;
            }
            if(%bricksfound >= 15) { // 15 bricks found is assumed to be indoors
                if(getRandom(1,16) == 1) { // play one??
                    %sound = getRandom(1,4);
					%n = getRandom(1,2);
					if(%n == 1){
						%sPos = getPosBehindPlayer(%player,4);
					}
					if(%n == 2){
						%sPos = getPosInFrontOfPlayer(%player,4);
					}
					//if(%n == 3){
						//%sPos = vectorAdd(%pPos, getRandom(-10,10) SPC getRandom(-10,10) SPC getRandom(-5,5) );
					//}
                    if(%sound == 1) {
                        serverPlay3D(Creak1,%sPos);
                    }
                    if(%sound == 2) {
                        serverPlay3D(Creak2,%sPos);
                    }
                    if(%sound == 3) {
                        serverPlay3D(Creak3,%sPos);
                    }
					if(%sound == 4) {
                        ServerPlay3D(Creak4,%sPos);
                    }
					if(getRandom(1,16) == 1 && $rendercurrentlystalking == 0) { // absolutely fuck with them?
						createRenderman(%sPos);
					}
					if($Pref::Renderman::Mode == 1) {
						$RMOD_Check = schedule(getRandom(3000,20000),0,RMOD_Check);  
						return; // disallow other random events until next time
					}
                }
            }
        }
		$RMOD_Check = schedule( getRandom(3000,20000), 0, RMOD_Check, %say[getRandom(0,%a)] );
		return;
	}
	$RMOD_Check = schedule( 60000, 0, RMOD_Check, %say[getRandom(0,%a)] );
}

//STOLEN FROM V3!!!!!!!!!!!!!!!!!!
function renderBreakLight(%targetObject) {
    if(%targetObject.isBroken != 1) { // can we do something about this light?
        %targetObject.isBroken = 1;
        %targetObject.prevLight = %targetObject.getLightID().getDatablock();
        %targetObject.prevFx = %targetObject.getColorFxID();
        %targetObject.setLight(0);
        %targetObject.setColorFx(0);
        %delay = getRandom(6000, 26000);
        schedule(%delay,0,renderRestoreLight,%targetObject);
        schedule(%delay,0,serverPlay3D,MapLightsOn,%targetObject.getPosition());
		//$renderactivity = 1;
        
        if(isObject(%targetObject.emitter)) { // if the target has an emitter we'll assume it's a torch or something
            %targetObject.prevEmitter = %targetObject.emitter.getEmitterDatablock().getName();
            %targetObject.setEmitter(0);
        } else {
            serverPlay3D(MapLightsOff,%targetObject.getPosition());
            %targetObject.prevEmitter = 0;
        }
    } else {
        renderAffectLight(%targetObject);
    }
}

function renderAffectLight(%targetObject) {
    %targetObject.prevLight = %targetObject.getLightID().getDatablock();
    %targetObject.prevFx = %targetObject.getColorFxID();
    %targetObject.setLight(0);
    %targetObject.setColorFx(0);
    
    if(isObject(%targetObject.emitter)) { // if the target has an emitter we'll assume it's a torch or something
        %targetObject.prevEmitter = %targetObject.emitter.getEmitterDatablock().getName();
        %targetObject.setEmitter(0);
    } else {
        %targetObject.prevEmitter = 0;
    }
    
    schedule(250,0,renderRestoreLight,%targetObject);  // just flicker
	//$renderactivity = 1;
}

function renderRestoreLight(%targetObject) {
    %targetObject.setLight(%targetObject.prevLight);
    %targetObject.setEmitter(%targetObject.prevEmitter);
    %targetObject.setColorFx(%targetObject.prevFx);
    
    if(isObject(%targetObject.emitter)) {
        %targetObject.isBroken = 0;
        return;
    }
    
    if(getRandom(1,3) != 1) {
        schedule(100,0,renderAffectLight,%targetObject);
    } else {
        %targetObject.isBroken = 0;
    }
}

function Player::stalkLoop(%this) {
    
    if(%this.shrinefound == 1 || $rendercurrentlystalking == 0) { // if he's near a shrine OR already stalking we can't do jack shit
        $rendercurrentlystalking = 0;
		$renderstalkcount = 0;
		return;
    }
    
    %cl = %this.client;
	if($renderstalkcount < 4) {
		%cl.play2d(RenderChaseSound1);
	} else if($renderstalkcount >= 5) {
		%cl.play2d(RenderChaseSound2);
	}
    %kPos = getPosInFrontOfPlayer(%this,3);
    %bPos = getPosBehindPlayer(%this,5);
	if(getRandom(0,11) >= 1) {
		%this.RStalk = %this.schedule(3000, "stalkLoop");
		$renderactivity = 4;
		$renderstalkcount++;
    } else {
		$renderactivity = 1;
		$rendercurrentlystalking = 0;
		$renderstalkcount = 0;
		return;
    }
    if(getRandom(0,5) == 1) {  // spawn behind chance
		createRenderman(%bPos);
		$rendercurrentlystalking = 0;
		$renderstalkcount = 0;
		return;
    }
    if(getRandom(0,28) == 1) {  // spawn in front of chance
		createRenderman(%kPos);
		$rendercurrentlystalking = 0;
		$renderstalkcount = 0;
		return;
    }
}

function Player::canSeeObject(%this, %object)
{    
	%ev = %this.getEyeVector();  // get the player's eye vector
	%pos = %this.getPosition();  // check where he is
	if(!isObject(%object)) // does the object exist?
		return 0;  // if it doesn't then fuck trying to find it
	%ep = isFunction(%object.getClassname(), getEyePoint) ? %object.getEyePoint() : %object.getPosition(); // check if the object's eyepoint can be got and if so get it's eye point and pos
	%vd = vectorDist(%pos, %ep);  // find how far away they are from each other
	if(%vd > 200)  // if they're further than reasonable distance,
		return 0; // sod it
	%brickcast = containerRaycast(%pos, %ep, $TypeMasks::FxBrickObjectType); // check if there are any bricks blocking the way
	if($Version <= 20) {	//so we don't waste time if we're on v21
		%interiorcast = containerRaycast(%pos, %ep, $TypeMasks::InteriorObjectType); // check if the interior is blocking the way
		%terraincast = containerRaycast(%pos, %ep, $TypeMasks::TerrainObjectType); // check if the terrain is blocking the way
	}
	if(isObject(%brickcast) || isObject(%interiorcast) || isObject(%terraincast)) // if you find anything blocking the view of the object,
		return 0;  // it must be unviewed.
	%adjp = vectorSub(%pos, %ep);  // do some maths
	%angle = mATan(getWord(%adjp,1), getWord(%adjp,0));
	%ea = mATan(getWord(%ev,1), getWord(%ev,0));
	%cansee = %ea - %angle;
	%canSee = mAbs(%canSee);
	if(%cansee > 3.92689 || %cansee < 2.35629)
		return 0;
	return 1; // conclude it can be seen if we got this far
}

function Player::CanSeeLoop(%this,%ticknum,%lastHorrorObjectSeen)
{
	%this.shrinefound = 0;
    if($Pref::Renderman::Enabled == 1) {	//dont need to waste resources
		InitContainerRadiusSearch(%this.gettransform(),16,$typemasks::fxbrickobjecttype);
		while((%target=containerSearchNext())!=0){
			if(%target.getdatablock().getname()$="brickRenderSafeData"){
				%this.shrinefound = 1;
			}
		}
	}
    
	if(%this.canSeeObject($HorrorObject)) //if the player can see renderman
	{
        %pPos = %this.getPosition();
		%rPos = $HorrorObject.getPosition();
		%distancetorender = vectordist(%pPos, %rPos);
		%cl = %this.client;
		
		if(isObject(%lastHorrorObjectSeen)) { // can't notice something twice, but we check if the player got too close
			if(%lastHorrorObjectSeen = $HorrorObject) {
				if(%distancetorender <= 7 && %rendercurrentlykilling == 0 && %this.shrinefound == 0 && $Pref::Renderman::Mode == 0) {
					%this.setdatablock("PlayerFrozenArmor");  // stop the player from moving
					%this.setVelocity("0 0 0");
					%cl.play2d(RenderDeath);
					$renderactivity = 5;
					%this.REx = %this.schedule(1900, "renderPreKick");
					%this.RKill = %this.schedule(2000, "renderKick");
					return;
				}
			}
		} else {
			%lastHorrorObjectSeen = $HorrorObject;
			if(%distancetorender >= 8 || %this.shrinefound == 1 || $Pref::Renderman::Mode == 1) { // are we at a safe distance OR did we find a shrine OR is he just haunting
				%n = getRandom(0, 3);  // select a noise
					if(%n == 0) {
						%cl.play2d(RenderNotice1);
					}
					if(%n == 1) {
						%cl.play2d(RenderNotice2);
					}
					if(%n == 2) {
						%cl.play2d(RenderNotice3);
					}
					if(%n == 3) {
						%cl.play2d(RenderNotice4);
					}
			} else {
				%this.setdatablock("PlayerFrozenArmor");  // stop the player from moving
				%this.setVelocity("0 0 0");
				%cl.play2d(RenderDeath);
				$renderactivity = 5;
				%this.REx = %this.schedule(1900, "renderPreKick");
				%this.RKill = %this.schedule(2000, "renderKick");
				return;
			}
		}
	}
    if(%this.getMountedImage(0) $= nameToID("RenderDetectorImage")) { // trying to detect rendermen are we
        if($renderactivity == 5) {
            if($Pref::Renderman::DetectorSound == 1) {
					ServerPlay3D(Beep_EKG_Sound,%this.getPosition());
				} else {
					ServerPlay3D(Detector,%this.getPosition());
				}
            %this.client.bottomPrint("<color:ffffff>Output: <color:ff0000>OFF SCALE GLITCH ACTIVITY DETECTED. EUCLID PRESCENCE CERTAIN.",1);
        } else if($renderactivity == 4) {
            if(%ticknum == 0 || %ticknum == 2 || %ticknum == 4 || %ticknum == 6 || %ticknum == 8 || %ticknum == 10 || %ticknum == 12) {
                if($Pref::Renderman::DetectorSound == 1) {
					ServerPlay3D(Beep_EKG_Sound,%this.getPosition());
				} else {
					ServerPlay3D(Detector,%this.getPosition());
				}
            }
            %this.client.bottomPrint("<color:ffffff>Output: <color:ff8000>Very high glitch energy reading detected. User advised to leave area as soon as possible.",1);
        } else if($renderactivity == 3) {
            if(%ticknum == 0 || %ticknum == 3 || %ticknum == 6 || %ticknum == 9 || %ticknum == 12) {
                if($Pref::Renderman::DetectorSound == 1) {
					ServerPlay3D(Beep_EKG_Sound,%this.getPosition());
				} else {
					ServerPlay3D(Detector,%this.getPosition());
				}
            }
            %this.client.bottomPrint("<color:ffffff>Output: <color:ffaa00>High glitch energy blip detected nearby. Euclid prescence possible. Stay clear.",1);
        } else if($renderactivity == 2) {
            if(%ticknum == 0 || %ticknum == 4 || %ticknum == 8 || %ticknum == 12) {
                if($Pref::Renderman::DetectorSound == 1) {
					ServerPlay3D(Beep_EKG_Sound,%this.getPosition());
				} else {
					ServerPlay3D(Detector,%this.getPosition());
				}
            }
            %this.client.bottomPrint("<color:ffffff>Output: <color:ffff00>Low glitch energy detected. Investigate.",1);
        } else if($renderactivity == 1) {
            if(%ticknum == 0) {
                if($Pref::Renderman::DetectorSound == 1) {
					ServerPlay3D(Beep_EKG_Sound,%this.getPosition());
				} else {
					ServerPlay3D(Detector,%this.getPosition());
				}
            }
            %this.client.bottomPrint("<color:ffffff>Output: <color:aaff00>Slight glitch energy trace detected. Investigate.",1);
        } else if($renderactivity == 0) {
            %this.client.bottomPrint("<color:ffffff>Output: <color:00ff00>No glitch energy detected.",1);
        }
    }
    
    %ticknum = %ticknum+1;
    
    if(%ticknum == 14) {
        %ticknum = 0;
    }
    
	%this.schedule(200,canSeeLoop,%ticknum,%lastHorrorObjectSeen);
}

function Player::renderKick(%this) {
    if(%this.client != findLocalClient()) {
        if($Pref::Renderman::Kick == 1) {
            %this.client.delete("^*%^&^%H&E^L$L%O%^$()^&{~@:~~}{");
        } else {
            %this.kill();
        }
    } else {
        %this.kill();
    }
}

function Player::renderPreKick(%this) {
    hideAllNodes(%this);
	%this.hidenode(headskin);	//because the head doesn't go away for some reason
	if(isObject(%this.light))
		{
			%this.light.delete();
		}
	ServerPlay2D(RenderAbduct,%this.getPosition()); // a seperate function so things don't mess up
}

// PACKAGES (Well, there's only one of them) //

package render
{
    function GameConnection::createPlayer(%cl, %trans)
	{
		Parent::createPlayer(%cl, %trans);
		if(isObject(%cl.player)) {
			%cl.player.CanSeeLoop(0);
        }
	}
};
activatePackage("render");

schedule(getRandom(15000,60000),0,RMOD_Check,"I'm here.");
//RMOD_Check();
//echo("RMOD_Check now active!");